# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from camera_aravis/CameraAutoInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class CameraAutoInfo(genpy.Message):
  _md5sum = "32531ce3cc5464cdedf0911c6f6b154c"
  _type = "camera_aravis/CameraAutoInfo"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Status of GenICam properties affected by auto-parameters
#
# GenICam is maintained by the european machine vision association (emva):
# https://www.genicam.org
#
# Properties are defined in GenICam Standard Features Naming Convention (SFNC).
# 
# Implementation of most properties is "optional".
# If a parameter is not implemented, it should be set to NaN.
#
# Note: Vendor specific extensions are not taken into account.
# Consider disabling such proprietary auto-parameters.

std_msgs/Header header

# ExposureAuto
float64 exposure_time

# GainAuto
float64 gain

# GainAutoBalance
float64 gain_red
float64 gain_green
float64 gain_blue

# BlackLevelAuto
float64 black_level

# BlackLevelAutoBalance
float64 bl_red
float64 bl_green
float64 bl_blue

# BalanceWhiteAuto
float64 wb_red
float64 wb_green
float64 wb_blue

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','exposure_time','gain','gain_red','gain_green','gain_blue','black_level','bl_red','bl_green','bl_blue','wb_red','wb_green','wb_blue']
  _slot_types = ['std_msgs/Header','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,exposure_time,gain,gain_red,gain_green,gain_blue,black_level,bl_red,bl_green,bl_blue,wb_red,wb_green,wb_blue

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(CameraAutoInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.exposure_time is None:
        self.exposure_time = 0.
      if self.gain is None:
        self.gain = 0.
      if self.gain_red is None:
        self.gain_red = 0.
      if self.gain_green is None:
        self.gain_green = 0.
      if self.gain_blue is None:
        self.gain_blue = 0.
      if self.black_level is None:
        self.black_level = 0.
      if self.bl_red is None:
        self.bl_red = 0.
      if self.bl_green is None:
        self.bl_green = 0.
      if self.bl_blue is None:
        self.bl_blue = 0.
      if self.wb_red is None:
        self.wb_red = 0.
      if self.wb_green is None:
        self.wb_green = 0.
      if self.wb_blue is None:
        self.wb_blue = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.exposure_time = 0.
      self.gain = 0.
      self.gain_red = 0.
      self.gain_green = 0.
      self.gain_blue = 0.
      self.black_level = 0.
      self.bl_red = 0.
      self.bl_green = 0.
      self.bl_blue = 0.
      self.wb_red = 0.
      self.wb_green = 0.
      self.wb_blue = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_12d().pack(_x.exposure_time, _x.gain, _x.gain_red, _x.gain_green, _x.gain_blue, _x.black_level, _x.bl_red, _x.bl_green, _x.bl_blue, _x.wb_red, _x.wb_green, _x.wb_blue))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 96
      (_x.exposure_time, _x.gain, _x.gain_red, _x.gain_green, _x.gain_blue, _x.black_level, _x.bl_red, _x.bl_green, _x.bl_blue, _x.wb_red, _x.wb_green, _x.wb_blue,) = _get_struct_12d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_12d().pack(_x.exposure_time, _x.gain, _x.gain_red, _x.gain_green, _x.gain_blue, _x.black_level, _x.bl_red, _x.bl_green, _x.bl_blue, _x.wb_red, _x.wb_green, _x.wb_blue))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 96
      (_x.exposure_time, _x.gain, _x.gain_red, _x.gain_green, _x.gain_blue, _x.black_level, _x.bl_red, _x.bl_green, _x.bl_blue, _x.wb_red, _x.wb_green, _x.wb_blue,) = _get_struct_12d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_12d = None
def _get_struct_12d():
    global _struct_12d
    if _struct_12d is None:
        _struct_12d = struct.Struct("<12d")
    return _struct_12d
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
